#include <bits/stdc++.h>

using namespace std;

int main()
{
    cin.tie(0);
    ios::sync_with_stdio(false);
    int T,N,M,S;
    cin>>T;
    for(int i=0;i<T;i++){
        cin>>N>>M>>S;

        unordered_set<int> ros;
        for(int j=0;j<S;j++){
            int te;
            cin>>te;
            ros.insert(te);
        }
        //for(const auto& de:ros)cout<<de<<"f\n";
        unordered_map<int,unordered_set<int>> m;
        for(int j=0;j<M;j++){
            int a,b;
            cin>>a>>b;
            m[a].insert(b);
            m[b].insert(a);
            /*
            if(!(N!=2&&ros.count(a)&&ros.count(b))){
            m[a].insert(b);
            m[b].insert(a);
            cm++;
            }
            */
        }
        //cout<<cm;
        //if(cm<N-1){cout<<-1;continue;}
        //BFS
        unordered_set<int> mar;
        queue<int> q;
        int mx=INT_MIN;
        int mxx;
        for(int mxi=1;mxi<N;mxi++){
            if(m[mxi].size()>mx&&!ros.count(mxi)){
                mx=m[mxi].size();
                mxx=mxi;
            }
        }
        q.push(mxx);
        mar.insert(mxx);
        vector<int> ans(2*N-2);
        int cnt=0;
        while(!q.empty()){
            int cur=q.front();
            q.pop();
            for(const auto& som:m[cur]){
                if(!mar.count(som)){
                    //ans.push_back({cur,som});
                    ans[cnt]=cur;
                    ans[cnt+1]=som;
                    cnt+=2;
                    if(!ros.count(som))q.push(som);
                    mar.insert(som);
                }
            }
        }
        if(cnt==2*N-2){
        cout<<N-1<<"\n";
        /*
        for(const auto& pars:ans){
            cout<<pars.first<<" "<<pars.second<<"\n";
        }
        */
        for(int parok=0;parok<2*N-2;parok+=2){
            cout<<ans[parok]<<" "<<ans[parok+1]<<"\n";
        }
        }else cout<<-1<<"\n";
    }
}